/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 * 
 * This file is part of de.bsvrz.pua.prot.
 * 
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.bsvrz.pua.prot.manager;

/**
 * Enthält die Operationscodes von Protokoll-bezogenen Operationen. Das Submodul Task Manager ({@link de.bsvrz.pua.prot.manager.taskmanager.TaskManagerInterface})
 * ist für die Abarbeitung dieser Aufträge zuständig. (Siehe Kapitel 2.1.2.2.2.1/2/5 im Feinetwurf)
 *
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $Revision$ / $Date$ / ($Author$)
 */
public class ProtocolRelatedOperation {

	/** Protokollerstellung. */
	public static final int CREATE = 1;

	/** Protokollerstellung abbrechen. */
	public static final int ABORT = 2;

	/** Gespeichertes Protokoll löschen. */
	public static final int DELETE = 3;

	/** Liste gespeicherter Protokole abrufen. */
	public static final int LIST = 4;

	/** Statusanfrage. */
	public static final int STATUS = 5;

	/** Gespeichertes Protokoll abrufen */
	public static final int SEND_SAVED_PROTOCOL = 6;

	/** Flußkontrolle: Senden des Protokolls anhalten. */
	public static final int PAUSE_PROTOCOL = 7;

	/** Flußkontrolle: Senden des Protokolls fortsetzen. */
	public static final int RESUME_PROTOCOL = 8;

	/** Noch nicht abgerufenes Protokoll senden. */
	public static final int SEND_UNREAD_PROTOCOL = 9;

	/** Liste mit noch nicht abgerufenen Protokollen abrufen. */
	public static final int UNREAD_PROTOCOL_LIST = 10;

	/** Prüfung ob PuA läuft und mit dem Archivsystem verbunden ist */
	public static final int PUA_ARS_STATUS = 11;

	/** Schnittstelle über die Protokoll-Fertigmeldungen angefordert bzw. verschickt werden */
	public static final int PROTOCOL_COMPLETION_INTERFACE = 12;

	/** Schnittstelle, über die in Warteschlange oder in Bearbeitung befindliche protokollbezogene Anfragen abgerufen werden können */
	public static final int JOB_LIST = 13;

	/** Automatische Flusskontrolle */
	public static final int FLOW_CONTROL = 14;

	/** Nicht gesetzt. */
	public static final int INVALID = 0;

	/** Auftrag erfolgreich ausgeführt. */
	public static final int ACK_FLAG = 200;

	/** Fehler. */
	public static final int NACK_FLAG = 100;
}
