
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "kernsysteme",
    "makrodefinitionen",
    "zugangDav",
    "usv",
    "rechner"
})
public class Global implements Serializable
{

    @JsonProperty("kernsysteme")
    private List<KernSystem> kernsysteme = new ArrayList<KernSystem>();
    @JsonProperty("makrodefinitionen")
    private List<MakroDefinition> makrodefinitionen = new ArrayList<MakroDefinition>();
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("zugangDav")
    private ZugangDav zugangDav;
    @JsonProperty("usv")
    private Usv usv;
    @JsonProperty("rechner")
    private List<Rechner> rechner = new ArrayList<Rechner>();
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 5594623760618631685L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Global() {
    }

    /**
     * 
     * @param rechner
     * @param makrodefinitionen
     * @param zugangDav
     * @param usv
     * @param kernsysteme
     */
    public Global(List<KernSystem> kernsysteme, List<MakroDefinition> makrodefinitionen, ZugangDav zugangDav, Usv usv, List<Rechner> rechner) {
        super();
        this.kernsysteme = kernsysteme;
        this.makrodefinitionen = makrodefinitionen;
        this.zugangDav = zugangDav;
        this.usv = usv;
        this.rechner = rechner;
    }

    @JsonProperty("kernsysteme")
    public List<KernSystem> getKernsysteme() {
        return kernsysteme;
    }

    @JsonProperty("kernsysteme")
    public void setKernsysteme(List<KernSystem> kernsysteme) {
        this.kernsysteme = kernsysteme;
    }

    public Global withKernsysteme(List<KernSystem> kernsysteme) {
        this.kernsysteme = kernsysteme;
        return this;
    }

    @JsonProperty("makrodefinitionen")
    public List<MakroDefinition> getMakrodefinitionen() {
        return makrodefinitionen;
    }

    @JsonProperty("makrodefinitionen")
    public void setMakrodefinitionen(List<MakroDefinition> makrodefinitionen) {
        this.makrodefinitionen = makrodefinitionen;
    }

    public Global withMakrodefinitionen(List<MakroDefinition> makrodefinitionen) {
        this.makrodefinitionen = makrodefinitionen;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("zugangDav")
    public ZugangDav getZugangDav() {
        return zugangDav;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("zugangDav")
    public void setZugangDav(ZugangDav zugangDav) {
        this.zugangDav = zugangDav;
    }

    public Global withZugangDav(ZugangDav zugangDav) {
        this.zugangDav = zugangDav;
        return this;
    }

    @JsonProperty("usv")
    public Usv getUsv() {
        return usv;
    }

    @JsonProperty("usv")
    public void setUsv(Usv usv) {
        this.usv = usv;
    }

    public Global withUsv(Usv usv) {
        this.usv = usv;
        return this;
    }

    @JsonProperty("rechner")
    public List<Rechner> getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(List<Rechner> rechner) {
        this.rechner = rechner;
    }

    public Global withRechner(List<Rechner> rechner) {
        this.rechner = rechner;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Global withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("kernsysteme", kernsysteme).append("makrodefinitionen", makrodefinitionen).append("zugangDav", zugangDav).append("usv", usv).append("rechner", rechner).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(rechner).append(makrodefinitionen).append(zugangDav).append(usv).append(additionalProperties).append(kernsysteme).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Global) == false) {
            return false;
        }
        Global rhs = ((Global) other);
        return new EqualsBuilder().append(rechner, rhs.rechner).append(makrodefinitionen, rhs.makrodefinitionen).append(zugangDav, rhs.zugangDav).append(usv, rhs.usv).append(additionalProperties, rhs.additionalProperties).append(kernsysteme, rhs.kernsysteme).isEquals();
    }

}
