
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyDescription;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "status",
    "messages"
})
public class StartStoppSkriptStatus implements Serializable
{

    /**
     * der Status der StartStoppApplikation
     * (Required)
     * 
     */
    @JsonProperty("status")
    @JsonPropertyDescription("der Status der StartStoppApplikation")
    private StartStoppSkriptStatus.Status status = StartStoppSkriptStatus.Status.fromValue("initialized");
    @JsonProperty("messages")
    private List<String> messages = new ArrayList<String>();
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -1382693016515907606L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartStoppSkriptStatus() {
    }

    /**
     * 
     * @param messages
     * @param status
     */
    public StartStoppSkriptStatus(StartStoppSkriptStatus.Status status, List<String> messages) {
        super();
        this.status = status;
        this.messages = messages;
    }

    /**
     * der Status der StartStoppApplikation
     * (Required)
     * 
     */
    @JsonProperty("status")
    public StartStoppSkriptStatus.Status getStatus() {
        return status;
    }

    /**
     * der Status der StartStoppApplikation
     * (Required)
     * 
     */
    @JsonProperty("status")
    public void setStatus(StartStoppSkriptStatus.Status status) {
        this.status = status;
    }

    public StartStoppSkriptStatus withStatus(StartStoppSkriptStatus.Status status) {
        this.status = status;
        return this;
    }

    @JsonProperty("messages")
    public List<String> getMessages() {
        return messages;
    }

    @JsonProperty("messages")
    public void setMessages(List<String> messages) {
        this.messages = messages;
    }

    public StartStoppSkriptStatus withMessages(List<String> messages) {
        this.messages = messages;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartStoppSkriptStatus withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("status", status).append("messages", messages).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(messages).append(additionalProperties).append(status).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartStoppSkriptStatus) == false) {
            return false;
        }
        StartStoppSkriptStatus rhs = ((StartStoppSkriptStatus) other);
        return new EqualsBuilder().append(messages, rhs.messages).append(additionalProperties, rhs.additionalProperties).append(status, rhs.status).isEquals();
    }

    public enum Status {

        INITIALIZED("initialized"),
        FAILURE("failure");
        private final String value;
        private final static Map<String, StartStoppSkriptStatus.Status> CONSTANTS = new HashMap<String, StartStoppSkriptStatus.Status>();

        static {
            for (StartStoppSkriptStatus.Status c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Status(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static StartStoppSkriptStatus.Status fromValue(String value) {
            StartStoppSkriptStatus.Status constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
